﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.IO;

using ProtoBuf;

using Vintagestory.API.Common;
using Vintagestory.API.Datastructures;

namespace Automap
{
	[ProtoContract(SkipConstructor = true)]
	//[ProtoInclude(5,typeof(DelegateState))]
	public class CommandData : IAttribute
	{
		[ProtoMember(1)]
		public CommandType State { get; set; }//Run , Stop, SingleSnapshot -> Stop



		[ProtoMember(3)]
		public string Notation { get; set; }

		//POI Delegate list {enabled/Disable}, color?
		//Other params...? Tick rate?
		//Choose : Renderer(s)


		public CommandData(CommandType assumeState)
		{
			State = assumeState;



		}


		public void FromBytes(BinaryReader stream)
		{
			var temp = ProtoBuf.Serializer.Deserialize<CommandData>(stream.BaseStream);
			this.State = temp.State;


		}

		public void ToBytes(BinaryWriter stream)
		{
			ProtoBuf.Serializer.Serialize<CommandData>(stream.BaseStream, this);


		}



		public int GetAttributeId()
		{
			return 12346;
		}

		public object GetValue()
		{
			return this;
		}


		public string ToJsonToken()
		{
			return $"Command-Type:{State} ";
		}

		public bool Equals(IWorldAccessor worldForResolve, IAttribute attr)
		{
			var other = attr.GetValue() as CommandData;

			if (this.State == other.State)
			{
				return true;
			}

			return false;
		}

		public IAttribute Clone( )
		{
		var cloneCmd = new CommandData(this.State);
		cloneCmd.Notation = this.Notation;
		return cloneCmd;
		}
	}
}

