﻿using System;
using System.Collections.Generic;

using Newtonsoft.Json;

namespace Automap
{
	
	public  class PersistedConfiguration
	{
		/// <summary>
		/// Run AM After a small delay when client has loaded fully
		/// </summary>
		/// <value>To autostart.</value>
		public bool Autostart { get; set; } = false;

		/// <summary>
		/// Use Same season effected colors as ingame-map.
		/// </summary>
		/// <value>The seasonal colors.</value>
		public bool SeasonalColors { get; set; } = true;

		/// <summary>
		/// Which appearance 'theme' should shards have?
		/// </summary>
		/// <value>'Standard' / 'Alternate' / 'Flat'</value>
		public string RendererName { get; set; } = @"Standard";

		//All - Designators, setup
		public List<BlockDesignator> BlockDesignators { get; set; }
		public List<EntityDesignator> EntityDesignators { get; set; }


		public PersistedConfiguration(bool defaults = false )
		{

		if (defaults) {
		BlockDesignators = DefaultDesignators.DefaultBlockDesignators;
		EntityDesignators= DefaultDesignators.DefaultEntityDesignators;
		}

		}


	}
}

