ViewFrame.initInfobox = function (ibox, iboxSlots) {

	ViewFrame.chunks
		.chunkMetadataNames.forEach((item, i) => {
			const slot = document.createElement('tr');
			const head = document.createElement('th');
			head.innerText = item;
			const row = document.createElement('td');
			row.innerText = '0';
			iboxSlots[i] = row;
			slot.append(head, row);
			ibox.append(slot);
		});
};

ViewFrame.prototype.updateEdges = function () {
	if (this.width != window.innerWidth || this.height != window.innerHeight) {
		this.width = window.innerWidth;
		this.map.canvas.width = this.width;
		this.height = window.innerHeight;
		this.map.canvas.height = this.height;
		this.map.imageSmoothingEnabled = false;
	}
	const chunksWide = Math.ceil(this.width / this.zoom);
	const chunksHigh = Math.ceil(this.height / this.zoom);

	this.east = this.x + chunksWide / 2; // this is fractional and is used to keep track of the edges of the window
	this.eastChunk = Math.ceil(this.east); // this is not and is used to track the chunks that need to load
	this.west = this.x - chunksWide / 2;
	this.westChunk = Math.floor(this.west);
	this.north = this.y + chunksHigh / 2;
	this.northChunk = Math.ceil(this.north);
	this.south = this.y - chunksHigh / 2;
	this.southChunk = Math.floor(this.south);
};

ViewFrame.prototype.moveCenter = function (dx, dy) {
	// to pan when we click on the map!
	this.x += (dx - this.width / 2) / this.zoom;
	this.y += (dy - this.height / 2) / this.zoom;
};
ViewFrame.prototype.setCenter = function (x, y) {
	this.x = x;
	this.y = y;
};

ViewFrame.prototype.clear = function () {
	this.loadedChunksByName.clear();
	this.loadedChunksByCoords.clear();
	if (this.chunkScript) this.chunkScript.remove();
	delete this.chunkScript;
	delete ViewFrame.chunks;
	this.map.clearRect(0, 0, window.innerWidth, window.innerHeight);
};

function decode(img, cb) {
	img.decode()
		.then(() => {
			cb(img);
		})
		.catch(() => {}); // so images arent added on error
}